  static inline Bit8u
bx_fetch_next_byte(void)
{
  Bit8u data8;

  if (bx_cpu.eip > bx_cpu.cs.cache.u.segment.limit_scaled) {
    bx_panic("fetch_next_byte: EIP > CS.limit\n");
    }
#if BX_CPU >= 3
  if (bx_cpu.cr0.pg) {
    bx_access_linear(bx_cpu.cs.cache.u.segment.base + bx_cpu.eip++,
                     1, CPL==3, BX_READ, &data8);
    return(data8);
    }
#endif

  bx_access_physical(bx_cpu.cs.cache.u.segment.base + bx_cpu.eip++,
                     1, BX_READ, &data8);
  return(data8);
}


  static inline Bit8u
bx_peek_next_byte(void)
{
  Bit8u data8;

  if (bx_cpu.eip > bx_cpu.cs.cache.u.segment.limit_scaled) {
    bx_panic("peek_next_byte: EIP > CS.limit\n");
    }
#if BX_CPU >= 3
  if (bx_cpu.cr0.pg) {
    bx_access_linear(bx_cpu.cs.cache.u.segment.base + bx_cpu.eip,
                     1, CPL==3, BX_READ, &data8);
    return(data8);
    }
#endif

  bx_access_physical(bx_cpu.cs.cache.u.segment.base + bx_cpu.eip,
                     1, BX_READ, &data8);
  return(data8);
}


  static inline Bit16u
bx_fetch_next_word(void)
{
  Bit16u data16;

  if (bx_cpu.eip > bx_cpu.cs.cache.u.segment.limit_scaled) {
    bx_panic("fetch_next_byte: EIP > CS.limit\n");
    }
#if BX_CPU >= 3
  if (bx_cpu.cr0.pg) {
    bx_access_linear(bx_cpu.cs.cache.u.segment.base + bx_cpu.eip,
                     2, CPL==3, BX_READ, &data16);
    bx_cpu.eip += 2;
    return(data16);
    }
#endif

  bx_access_physical(bx_cpu.cs.cache.u.segment.base + bx_cpu.eip,
                     2, BX_READ, &data16);
  bx_cpu.eip += 2;
  return(data16);
}


#if BX_CPU >= 3
  static inline Bit32u
bx_fetch_next_dword(void)
{
  Bit32u data32;

  if (bx_cpu.eip > bx_cpu.cs.cache.u.segment.limit_scaled) {
    bx_panic("fetch_next_byte: EIP > CS.limit\n");
    }
#if BX_CPU >= 3
  if (bx_cpu.cr0.pg) {
    bx_access_linear(bx_cpu.cs.cache.u.segment.base + bx_cpu.eip,
                     4, CPL==3, BX_READ, &data32);
    bx_cpu.eip += 4;
    return(data32);
    }
#endif

  bx_access_physical(bx_cpu.cs.cache.u.segment.base + bx_cpu.eip,
                     4, BX_READ, &data32);
  bx_cpu.eip += 4;
  return(data32);
}
#endif
