/*
Copyright Notice
================
BOCHS is Copyright 1994,1995,1996 by Kevin P. Lawton.

BOCHS is shareware for PERSONAL USE only.

For more information, read the file 'LICENSE' included in the bochs
distribution.  If you don't have access to this file, or have questions
regarding the licensing policy, the author may be contacted via:

    US Mail:  Kevin Lawton
              528 Lexington St.
              Waltham, MA 02154

    EMail:    bochs@world.std.com
*/





/* ------ One byte opcode stuff ------ */
/* 0x00 - 0x0F */
INLINE void bx_ADD_EbGb(void);
INLINE void bx_ADD_EvGv(void);
INLINE void bx_ADD_GbEb(void);
INLINE void bx_ADD_GvEv(void);
INLINE void bx_ADD_ALIb(void);
INLINE void bx_ADD_eAXIv(void);
INLINE void bx_PUSH_ES(void);
INLINE void bx_POP_ES(void);
INLINE void bx_OR_EbGb(void);
INLINE void bx_OR_EvGv(void);
INLINE void bx_OR_GbEb(void);
INLINE void bx_OR_GvEv(void);
INLINE void bx_OR_ALIb(void);
INLINE void bx_OR_eAXIv(void);
INLINE void bx_PUSH_CS(void);

/* 0x10 - 0x1F */
INLINE void bx_ADC_EbGb(void);
INLINE void bx_ADC_EvGv(void);
INLINE void bx_ADC_GbEb(void);
INLINE void bx_ADC_GvEv(void);
INLINE void bx_ADC_ALIb(void);
INLINE void bx_ADC_eAXIv(void);
INLINE void bx_PUSH_SS(void);
INLINE void bx_POP_SS(void);
INLINE void bx_SBB_EbGb(void);
INLINE void bx_SBB_EvGv(void);
INLINE void bx_SBB_GbEb(void);
INLINE void bx_SBB_GvEv(void);
INLINE void bx_SBB_ALIb(void);
INLINE void bx_SBB_eAXIv(void);
INLINE void bx_PUSH_DS(void);
INLINE void bx_POP_DS(void);

/* 0x20 - 0x2F */
INLINE void bx_AND_EbGb(void);
INLINE void bx_AND_EvGv(void);
INLINE void bx_AND_GbEb(void);
INLINE void bx_AND_GvEv(void);
INLINE void bx_AND_ALIb(void);
INLINE void bx_AND_eAXIv(void);
INLINE void bx_DAA(void);
INLINE void bx_SUB_EbGb(void);
INLINE void bx_SUB_EvGv(void);
INLINE void bx_SUB_GbEb(void);
INLINE void bx_SUB_GvEv(void);
INLINE void bx_SUB_ALIb(void);
INLINE void bx_SUB_eAXIv(void);
INLINE void bx_DAS(void);

/* 0x30 - 0x3F */
INLINE void bx_XOR_EbGb(void);
INLINE void bx_XOR_EvGv(void);
INLINE void bx_XOR_GbEb(void);
INLINE void bx_XOR_GvEv(void);
INLINE void bx_XOR_ALIb(void);
INLINE void bx_XOR_eAXIv(void);
INLINE void bx_AAA(void);
INLINE void bx_CMP_EbGb(void);
INLINE void bx_CMP_EvGv(void);
INLINE void bx_CMP_GbEb(void);
INLINE void bx_CMP_GvEv(void);
INLINE void bx_CMP_ALIb(void);
INLINE void bx_CMP_eAXIv(void);
INLINE void bx_AAS(void);

/* 0x40 - 0x4F */
INLINE void bx_INC_eAX(void);
INLINE void bx_INC_eCX(void);
INLINE void bx_INC_eDX(void);
INLINE void bx_INC_eBX(void);
INLINE void bx_INC_eSP(void);
INLINE void bx_INC_eBP(void);
INLINE void bx_INC_eSI(void);
INLINE void bx_INC_eDI(void);
INLINE void bx_DEC_eAX(void);
INLINE void bx_DEC_eCX(void);
INLINE void bx_DEC_eDX(void);
INLINE void bx_DEC_eBX(void);
INLINE void bx_DEC_eSP(void);
INLINE void bx_DEC_eBP(void);
INLINE void bx_DEC_eSI(void);
INLINE void bx_DEC_eDI(void);

/* 0x50 - 0x5F */
INLINE void bx_PUSH_eAX(void);
INLINE void bx_PUSH_eCX(void);
INLINE void bx_PUSH_eDX(void);
INLINE void bx_PUSH_eBX(void);
INLINE void bx_PUSH_eSP(void);
INLINE void bx_PUSH_eBP(void);
INLINE void bx_PUSH_eSI(void);
INLINE void bx_PUSH_eDI(void);
INLINE void bx_POP_eAX(void);
INLINE void bx_POP_eCX(void);
INLINE void bx_POP_eDX(void);
INLINE void bx_POP_eBX(void);
INLINE void bx_POP_eSP(void);
INLINE void bx_POP_eBP(void);
INLINE void bx_POP_eSI(void);
INLINE void bx_POP_eDI(void);

/* 0x60 - 0x6F */
INLINE void bx_PUSHAD(void);
INLINE void bx_POPAD(void);
INLINE void bx_BOUND_GvMa(void);
INLINE void bx_ARPL_EwGw(void);
INLINE void bx_PUSH_Iv(void);
INLINE void bx_IMUL_GvEvIv(void);
INLINE void bx_PUSH_Ib(void);
INLINE void bx_IMUL_GvEvIb(void);
INLINE void bx_INSB_YbDX(void);
INLINE void bx_INSW_YvDX(void);
INLINE void bx_OUTSB_DXXb(void);
INLINE void bx_OUTSW_DXXv(void);

/* 0x70 - 0x7F */
INLINE void bx_JO_Jb(void);
INLINE void bx_JNO_Jb(void);
INLINE void bx_JB_Jb(void);
INLINE void bx_JNB_Jb(void);
INLINE void bx_JZ_Jb(void);
INLINE void bx_JNZ_Jb(void);
INLINE void bx_JBE_Jb(void);
INLINE void bx_JNBE_Jb(void);
INLINE void bx_JS_Jb(void);
INLINE void bx_JNS_Jb(void);
INLINE void bx_JP_Jb(void);
INLINE void bx_JNP_Jb(void);
INLINE void bx_JL_Jb(void);
INLINE void bx_JNL_Jb(void);
INLINE void bx_JLE_Jb(void);
INLINE void bx_JNLE_Jb(void);

/* 0x80 - 0x8F */
/* NULL, GROUP1 EbIb */
/* NULL, GROUP1 EvIv */
/* NULL, INVALID */
/* NULL, GROUP1 EvIb */
INLINE void bx_TEST_EbGb(void);
INLINE void bx_TEST_EvGv(void);
INLINE void bx_XCHG_EbGb(void);
INLINE void bx_XCHG_EvGv(void);
INLINE void bx_MOV_EbGb(void);
INLINE void bx_MOV_EvGv(void);
INLINE void bx_MOV_GbEb(void);
INLINE void bx_MOV_GvEv(void);
INLINE void bx_MOV_EwSw(void);
INLINE void bx_LEA_GvM(void);
INLINE void bx_MOV_SwEw(void);
INLINE void bx_POP_Ev(void);

/* 0x90 - 0x9F */
/* NULL, NOP */
INLINE void bx_XCHG_eDXeAX(void);
INLINE void bx_XCHG_eBXeAX(void);
INLINE void bx_XCHG_eSPeAX(void);
INLINE void bx_XCHG_eBPeAX(void);
INLINE void bx_XCHG_eSIeAX(void);
INLINE void bx_XCHG_eDIeAX(void);
INLINE void bx_CBW(void);
INLINE void bx_CWD(void);
INLINE void bx_CALL_Ap(void);
INLINE void bx_WAIT(void);
INLINE void bx_PUSHF_Fv(void);
INLINE void bx_POPF_Fv(void);
INLINE void bx_SAHF(void);
INLINE void bx_LAHF(void);

/* 0xA0 - 0xAF */
INLINE void bx_MOV_ALOb(void);
INLINE void bx_MOV_eAXOv(void);
INLINE void bx_MOV_ObAL(void);
INLINE void bx_MOV_OveAX(void);
INLINE void bx_MOVSB_XbYb(void);
INLINE void bx_MOVSW_XvYv(void);
INLINE void bx_CMPSB_XbYb(void);
INLINE void bx_CMPSW_XvYv(void);
INLINE void bx_TEST_ALIb(void);
INLINE void bx_TEST_eAXIv(void);
INLINE void bx_STOSB_YbAL(void);
INLINE void bx_STOSW_YveAX(void);
INLINE void bx_LODSB_ALXb(void);
INLINE void bx_LODSW_eAXXv(void);
INLINE void bx_SCASB_ALXb(void);
INLINE void bx_SCASW_eAXXv(void);

/* 0xB0 - 0xBF */
INLINE void bx_MOV_ALIb(void);
INLINE void bx_MOV_CLIb(void);
INLINE void bx_MOV_DLIb(void);
INLINE void bx_MOV_BLIb(void);
INLINE void bx_MOV_AHIb(void);
INLINE void bx_MOV_CHIb(void);
INLINE void bx_MOV_DHIb(void);
INLINE void bx_MOV_BHIb(void);
INLINE void bx_MOV_eAXIv(void);
INLINE void bx_MOV_eCXIv(void);
INLINE void bx_MOV_eDXIv(void);
INLINE void bx_MOV_eBXIv(void);
INLINE void bx_MOV_eSPIv(void);
INLINE void bx_MOV_eBPIv(void);
INLINE void bx_MOV_eSIIv(void);
INLINE void bx_MOV_eDIIv(void);

/* 0xC0 - 0xCF */
/* NULL, group 2 */
/* NULL, group 2 */
INLINE void bx_RETnear(void);
INLINE void bx_LES_GvMp(void);
INLINE void bx_LDS_GvMp(void);
INLINE void bx_MOV_EbIb(void);
INLINE void bx_MOV_EvIv(void);
INLINE void bx_ENTER_IwIb(void);
INLINE void bx_LEAVE(void);
INLINE void bx_RETfar(void);
INLINE void bx_INT3(void);
INLINE void bx_INT_Ib(void);
INLINE void bx_INTO(void);
INLINE void bx_IRET(void);

/* 0xD0 - 0xDF */
/* group2 Eb1 */
/* group2 Ev1 */
/* group2 EbCL */
/* group2 EvCL */
INLINE void bx_AAM(void);
INLINE void bx_AAD(void);
/* NULL, INVALID */
INLINE void bx_XLAT(void);
/* NULL, ESC0 */
/* NULL, ESC1 */
/* NULL, ESC2 */
/* NULL, ESC3 */
/* NULL, ESC4 */
/* NULL, ESC5 */
/* NULL, ESC6 */
/* NULL, ESC7 */

/* 0xE0 - 0xEF */
INLINE void bx_LOOPNE_Jb(void);
INLINE void bx_LOOPE_Jb(void);
INLINE void bx_LOOP_Jb(void);
INLINE void bx_JCXZ_Jb(void);
INLINE void bx_IN_ALIb(void);
INLINE void bx_IN_eAXIb(void);
INLINE void bx_OUT_IbAL(void);
INLINE void bx_OUT_IbeAX(void);
INLINE void bx_CALL_Av(void);
INLINE void bx_JMP_Jv(void);
INLINE void bx_JMP_Ap(void);
INLINE void bx_JMP_Jb(void);
INLINE void bx_IN_ALDX(void);
INLINE void bx_IN_eAXDX(void);
INLINE void bx_OUT_DXAL(void);
INLINE void bx_OUT_DXeAX(void);

/* 0xF0 - 0xFF */
/* NULL, LOCK */
/* NULL, INVALID */
/* NULL, REPNE */
/* NULL, REP */
INLINE void bx_HLT(void);
INLINE void bx_CMC(void);
/* NULL, GROUP3 Eb */
/* NULL, GROUP3 Ev */
INLINE void bx_CLC(void);
INLINE void bx_STC(void);
INLINE void bx_CLI(void);
INLINE void bx_STI(void);
INLINE void bx_CLD(void);
INLINE void bx_STD(void);
/* NULL, GROUP4 */
/* NULL, GROUP5 */


/* ------ Two byte opcode stuff ------ */
/* 0x00 - 0x0F */
/* NULL, GROUP6 */
/* NULL, GROUP7 */
INLINE void bx_LAR_GvEw(void);
INLINE void bx_LSL_GvEw(void);
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_CLTS(void);
/* NULL, INVALID */
INLINE void bx_INVD(void);
INLINE void bx_WBINVD(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* 0x10 - 0x1F */
INLINE void bx_INVLPG_Ea(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* 0x20 - 0x2F */
INLINE void bx_MOV_CdRd(void);
INLINE void bx_MOV_DdRd(void);
INLINE void bx_MOV_RdCd(void);
INLINE void bx_MOV_RdDd(void);
INLINE void bx_MOV_TdRd(void);
/* NULL, INVALID */
INLINE void bx_MOV_RdTd(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* 0x30 - 0x3F */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* 0x40 - Ox4F */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* 0x50 - 0x5F */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* 0x60 - 0x6F */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* 0x70 - 0x7F */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* 0x80 - 0x8F */
INLINE void bx_JO_Jv(void);
INLINE void bx_JNO_Jv(void);
INLINE void bx_JB_Jv(void);
INLINE void bx_JNB_Jv(void);
INLINE void bx_JZ_Jv(void);
INLINE void bx_JNZ_Jv(void);
INLINE void bx_JBE_Jv(void);
INLINE void bx_JNBE_Jv(void);
INLINE void bx_JS_Jv(void);
INLINE void bx_JNS_Jv(void);
INLINE void bx_JP_Jv(void);
INLINE void bx_JNP_Jv(void);
INLINE void bx_JL_Jv(void);
INLINE void bx_JNL_Jv(void);
INLINE void bx_JLE_Jv(void);
INLINE void bx_JNLE_Jv(void);

/* 0x90 - 0x9F */
INLINE void bx_SETO_Eb(void);
INLINE void bx_SETNO_Eb(void);
INLINE void bx_SETB_Eb(void);
INLINE void bx_SETNB_Eb(void);
INLINE void bx_SETZ_Eb(void);
INLINE void bx_SETNZ_Eb(void);
INLINE void bx_SETBE_Eb(void);
INLINE void bx_SETNBE_Eb(void);
INLINE void bx_SETS_Eb(void);
INLINE void bx_SETNS_Eb(void);
INLINE void bx_SETP_Eb(void);
INLINE void bx_SETNP_Eb(void);
INLINE void bx_SETL_Eb(void);
INLINE void bx_SETNL_Eb(void);
INLINE void bx_SETLE_Eb(void);
INLINE void bx_SETNLE_Eb(void);

/* A0 - AF */
INLINE void bx_PUSH_FS(void);
INLINE void bx_POP_FS(void);
INLINE void bx_CPUID(void);
INLINE void bx_BT_EvGv(void);
INLINE void bx_SHLD_EvGvIb(void);
INLINE void bx_SHLD_EvGvCL(void);


INLINE void bx_PUSH_GS(void);
INLINE void bx_POP_GS(void);
/* NULL, INVALID */
INLINE void bx_BTS_EvGv(void);
INLINE void bx_SHRD_EvGvIb(void);
INLINE void bx_SHRD_EvGvCL(void);
/* NULL, INVALID */
INLINE void bx_IMUL_GvEv(void);

/* B0 - BF */
INLINE void bx_LSS_GvMp(void);
INLINE void bx_BTR_EvGv(void);
INLINE void bx_LFS_GvMp(void);
INLINE void bx_LGS_GvMp(void);
INLINE void bx_MOVZX_GvEb(void);
INLINE void bx_MOVZX_GvEw(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, GROUP8 EvIb */
INLINE void bx_BTC_EvGv(void);
INLINE void bx_BSF_GvEv(void);
INLINE void bx_BSR_GvEv(void);
INLINE void bx_MOVSX_GvEb(void);
INLINE void bx_MOVSX_GvEw(void);

/* C0 - CF */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_BSWAP_EAX(void);
INLINE void bx_BSWAP_ECX(void);
INLINE void bx_BSWAP_EDX(void);
INLINE void bx_BSWAP_EBX(void);
INLINE void bx_BSWAP_ESP(void);
INLINE void bx_BSWAP_EBP(void);
INLINE void bx_BSWAP_ESI(void);
INLINE void bx_BSWAP_EDI(void);

/* D0 - DF */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* E0 - EF */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* F0 - FF */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */


/* --------- MOD R/M OPCODE STUFF -------- */

/* GROUP1[EbIb] */
INLINE void bx_ADD_EbIb(void);
INLINE void bx_OR_EbIb(void);
INLINE void bx_ADC_EbIb(void);
INLINE void bx_SBB_EbIb(void);
INLINE void bx_AND_EbIb(void);
INLINE void bx_SUB_EbIb(void);
INLINE void bx_XOR_EbIb(void);
INLINE void bx_CMP_EbIb(void);

/* GROUP1[EvIv] */
INLINE void bx_ADD_EvIv(void);
INLINE void bx_OR_EvIv(void);
INLINE void bx_ADC_EvIv(void);
INLINE void bx_SBB_EvIv(void);
INLINE void bx_AND_EvIv(void);
INLINE void bx_SUB_EvIv(void);
INLINE void bx_XOR_EvIv(void);
INLINE void bx_CMP_EvIv(void);

/* GROUP1[EvIb] */
INLINE void bx_ADD_EvIb(void);
INLINE void bx_OR_EvIb(void);
INLINE void bx_ADC_EvIb(void);
INLINE void bx_SBB_EvIb(void);
INLINE void bx_AND_EvIb(void);
INLINE void bx_SUB_EvIb(void);
INLINE void bx_XOR_EvIb(void);
INLINE void bx_CMP_EvIb(void);

/* GROUP2[EbIb] */
INLINE void bx_ROL_EbIb(void);
INLINE void bx_ROR_EbIb(void);
INLINE void bx_RCL_EbIb(void);
INLINE void bx_RCR_EbIb(void);
INLINE void bx_SHL_EbIb(void);
INLINE void bx_SHR_EbIb(void);
/* NULL, INVALID */
INLINE void bx_SAR_EbIb(void);

/* GROUP2[EvIb] */
INLINE void bx_ROL_EvIb(void);
INLINE void bx_ROR_EvIb(void);
INLINE void bx_RCL_EvIb(void);
INLINE void bx_RCR_EvIb(void);
INLINE void bx_SHL_EvIb(void);
INLINE void bx_SHR_EvIb(void);
/* NULL, INVALID */
INLINE void bx_SAR_EvIb(void);

/* GROUP2[Eb1] */
INLINE void bx_ROL_Eb1(void);
INLINE void bx_ROR_Eb1(void);
INLINE void bx_RCL_Eb1(void);
INLINE void bx_RCR_Eb1(void);
INLINE void bx_SHL_Eb1(void);
INLINE void bx_SHR_Eb1(void);
/* NULL, INVALID */
INLINE void bx_SAR_Eb1(void);

/* GROUP2[Ev1] */
INLINE void bx_ROL_Ev1(void);
INLINE void bx_ROR_Ev1(void);
INLINE void bx_RCL_Ev1(void);
INLINE void bx_RCR_Ev1(void);
INLINE void bx_SHL_Ev1(void);
INLINE void bx_SHR_Ev1(void);
/* NULL, INVALID */
INLINE void bx_SAR_Ev1(void);

/* GROUP2[EbCL] */
INLINE void bx_ROL_EbCL(void);
INLINE void bx_ROR_EbCL(void);
INLINE void bx_RCL_EbCL(void);
INLINE void bx_RCR_EbCL(void);
INLINE void bx_SHL_EbCL(void);
INLINE void bx_SHR_EbCL(void);
/* NULL, INVALID */
INLINE void bx_SAR_EbCL(void);

/* GROUP2[EvCL] */
INLINE void bx_ROL_EvCL(void);
INLINE void bx_ROR_EvCL(void);
INLINE void bx_RCL_EvCL(void);
INLINE void bx_RCR_EvCL(void);
INLINE void bx_SHL_EvCL(void);
INLINE void bx_SHR_EvCL(void);
/* NULL, INVALID */
INLINE void bx_SAR_EvCL(void);

/* GROUP3[Eb] */
INLINE void bx_TEST_EbIb(void);
/* NULL, INVALID */
INLINE void bx_NOT_Eb(void);
INLINE void bx_NEG_Eb(void);
INLINE void bx_MUL_ALEb(void);
INLINE void bx_IMUL_ALEb(void);
INLINE void bx_DIV_ALEb(void);
INLINE void bx_IDIV_ALEb(void);

/* GROUP3[Ev] */
INLINE void bx_TEST_EvIv(void);
/* NULL, INVALID */
INLINE void bx_NOT_Ev(void);
INLINE void bx_NEG_Ev(void);
INLINE void bx_MUL_eAXEv(void);
INLINE void bx_IMUL_eAXEv(void);
INLINE void bx_DIV_eAXEv(void);
INLINE void bx_IDIV_eAXEv(void);

/* GROUP4[] */
INLINE void bx_INC_Eb(void);
INLINE void bx_DEC_Eb(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* GROUP5[] */
INLINE void bx_INC_Ev(void);
INLINE void bx_DEC_Ev(void);
INLINE void bx_CALL_Ev(void);
INLINE void bx_CALL_Ep(void);
INLINE void bx_JMP_Ev(void);
INLINE void bx_JMP_Ep(void);
INLINE void bx_PUSH_Ev(void);
/* NULL, INVALID */

/* GROUP6[] */
INLINE void bx_SLDT_Ew(void);
INLINE void bx_STR_Ew(void);
INLINE void bx_LLDT_Ew(void);
INLINE void bx_LTR_Ew(void);
INLINE void bx_VERR_Ew(void);
INLINE void bx_VERW_Ew(void);
/* NULL, INVALID */
/* NULL, INVALID */

/* GROUP7[] */
INLINE void bx_SGDT_Ms(void);
INLINE void bx_SIDT_Ms(void);
INLINE void bx_LGDT_Ms(void);
INLINE void bx_LIDT_Ms(void);
INLINE void bx_SMSW_Ew(void);
/* NULL, INVALID */
INLINE void bx_LMSW_Ew(void);
/* NULL, INVALID */


/* GROUP8[EvIb] */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_BT_EvIb(void);
INLINE void bx_BTS_EvIb(void);
INLINE void bx_BTR_EvIb(void);
INLINE void bx_BTC_EvIb(void);

/* ------ NDP ESCAPES 0-7 --------- */

/* NDP ESC 0 */
INLINE void bx_FADD_Es(void);
INLINE void bx_FMUL_Es(void);
INLINE void bx_FCOM_Es(void);
INLINE void bx_FCOMP_Es(void);
INLINE void bx_FSUB_Es(void);
INLINE void bx_FSUBR_Es(void);
INLINE void bx_FDIV_Es(void);
INLINE void bx_FDIVR_Es(void);

INLINE void bx_FADD_ST_STi(void);
INLINE void bx_FMUL_ST_STi(void);
INLINE void bx_FCOM_ST_STi(void);
INLINE void bx_FCOMP_ST_STi(void);
INLINE void bx_FSUB_ST_STi(void);
INLINE void bx_FSUBR_ST_STi(void);
INLINE void bx_FDIV_ST_STi(void);
INLINE void bx_FDIVR_ST_STi(void);

/* NDP ESC 1 */
INLINE void bx_FLD_Es(void);
/* NULL, INVALID */
INLINE void bx_FST_Es(void);
INLINE void bx_FSTP_Es(void);
INLINE void bx_FLDENV_Ea(void);
INLINE void bx_FLDCW_Ew(void);
INLINE void bx_FSTENV_Ea(void);
INLINE void bx_FSTCW_Ew(void);

INLINE void bx_FNOP(void);
/* NULL, INVALID */
INLINE void bx_FCHS(void);
INLINE void bx_FLD1(void);
INLINE void bx_F2XM1(void);
INLINE void bx_FPREM(void);

/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_FABS(void);
INLINE void bx_FLDL2T(void);
INLINE void bx_FYL2X(void);
INLINE void bx_FYL2XP1(void);

/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_FLDL2E(void);
INLINE void bx_FPTAN(void);
INLINE void bx_FSQRT(void);

INLINE void bx_FXCH_3(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_FLDPI(void);
INLINE void bx_FPATAN(void);
INLINE void bx_FSINCOS(void);

/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_FTST(void);
INLINE void bx_FLDLG2(void);
INLINE void bx_FXTRACT(void);
INLINE void bx_FRNDINT(void);

/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_FXAM(void);
INLINE void bx_FSCALE(void);

/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_FLDZ(void);
INLINE void bx_FDECSTP(void);
INLINE void bx_FSIN(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_FINCSTP(void);
INLINE void bx_FCOS(void);

/* NDP ESC 2 */
INLINE void bx_FIADD_Ew(void);
INLINE void bx_FIMUL_Ew(void);
INLINE void bx_FICOM_Ew(void);
INLINE void bx_FICOMP_Ew(void);
INLINE void bx_FISUB_Ew(void);
INLINE void bx_FISUBR_Ew(void);
INLINE void bx_FIDIV_Ew(void);
INLINE void bx_FIDIVR_Ew(void);

/* NULL, INVALID */
INLINE void bx_FUCOMPP(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* NDP ESC 3 */
INLINE void bx_FILD_Ew(void);
/* NULL, INVALID */
INLINE void bx_FIST_Ew(void);
INLINE void bx_FISTP_Ew(void);
INLINE void bx_FLD_Et(void);
/* NULL, INVALID */
INLINE void bx_FSTP_Et(void);
/* NULL, INVALID */

/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, GROUP3A */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* NDP ESC 3, GROUP3a */
INLINE void bx_FENI(void);
INLINE void bx_FDISI(void);
INLINE void bx_FCLEX(void);
INLINE void bx_FINIT(void);
INLINE void bx_FSETPM(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* NDP ESC 4 */
INLINE void bx_FADD_El(void);
INLINE void bx_FMUL_El(void);
INLINE void bx_FCOM_El(void);
INLINE void bx_FCOMP_El(void);
INLINE void bx_FSUB_El(void);
INLINE void bx_FSUBR_El(void);
INLINE void bx_FDIV_El(void);
INLINE void bx_FDIVR_El(void);

INLINE void bx_FADD_STi_ST(void);
INLINE void bx_FMUL_STi_ST(void);
INLINE void bx_FCOM_STi_ST(void);
INLINE void bx_FCOMP_STi_ST(void);
INLINE void bx_FSUB_STi_ST(void);
INLINE void bx_FSUBR_STi_ST(void);
INLINE void bx_FDIV_STi_ST(void);
INLINE void bx_FDIVR_STi_ST(void);

/* NDP ESC 5 */
INLINE void bx_FLD_El(void);
/* NULL, INVALID */
INLINE void bx_FST_El(void);
INLINE void bx_FSTP_El(void);
INLINE void bx_FRSTOR_Ea(void);
/* NULL, INVALID */
INLINE void bx_FSAVE_Ea(void);
INLINE void bx_FSTSW_Ew(void);

INLINE void bx_FFREE_STi(void);
/* NULL, INVALID */
INLINE void bx_FST_STi(void);
INLINE void bx_FSTP_STi(void);
INLINE void bx_FUCOMP_STi(void);
/* NULL, INVALID */
/* NULL, INVALID */

/* NDP ESC 6 */
INLINE void bx_FIADD_Ed(void);
INLINE void bx_FIMUL_Ed(void);
INLINE void bx_FICOM_Ed(void);
INLINE void bx_FICOMP_Ed(void);
INLINE void bx_FISUB_Ed(void);
INLINE void bx_FISUBR_Ed(void);
INLINE void bx_FIDIV_Ed(void);
INLINE void bx_FIDIVR_Ed(void);

INLINE void bx_FADDP_STi_ST(void);
INLINE void bx_FMULP_STi_ST(void);
/* NULL, INVALID */
INLINE void bx_FCOMPP(void);
INLINE void bx_FSUBP_STi_ST(void);
INLINE void bx_FSUBRP_STi_ST(void);
INLINE void bx_FDIVP_STi_ST(void);
INLINE void bx_FDIVRP_STi_ST(void);

/* NDP ESC 7 */
INLINE void bx_FILD_Ed(void);
/* NULL, INVALID */
INLINE void bx_FIST_Ed(void);
INLINE void bx_FISTP_Ed(void);
INLINE void bx_FBLD_Eb(void);
INLINE void bx_FILD_Eq(void);
INLINE void bx_FBSTP_Eb(void);
INLINE void bx_FISTP_Eq(void);

INLINE void bx_FSTSW_AX(void);
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */



INLINE void bx_CMPXCHG_XBTS(void);
INLINE void bx_CMPXCHG_IBTS(void);
INLINE void bx_CMPXCHG_EbGb(void);
INLINE void bx_CMPXCHG_EvGv(void);
INLINE void bx_XADD_EbGb(void);
INLINE void bx_XADD_EvGv(void);
INLINE void bx_XCHG_eCXeAX(void);
INLINE void bx_RETnear_Iw(void);
INLINE void bx_RETfar_Iw(void);
INLINE void bx_FLD_STi(void);
INLINE void bx_FXCH_STi(void);
INLINE void bx_FLDLN2(void);
INLINE void bx_FPREM1(void);
INLINE void bx_FUCOM_STi_ST(void);
INLINE void bx_FCOMP_STi(void);

void bx_PSEUDO_INT_Ib(void);

INLINE void bx_LOADALL(void);
